org.apache.xpath.operations

## Class Operation

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.operations.Operation

- All Implemented Interfaces:
    java.io.Serializable, SourceLocator, ExpressionNode, ExpressionOwner, XPathVisitable
  Direct Known Subclasses:
    And, Div, Equals, Gt, Gte, Lt, Lte, Minus, Mod, Mult, NotEquals, Or, Plus, Quo

      public class Operation
      extends Expression
      implements ExpressionOwner

  The baseclass for a binary operation.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Operation()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `callVisitors(ExpressionOwner owner, XPathVisitor visitor)` This will traverse the heararchy, calling the visitor for each member.
    `boolean` | `canTraverseOutsideSubtree()` Tell if this expression or it's subexpressions can traverse outside the current subtree.
    `boolean` | `deepEquals(Expression expr)` Compare this object with another object and see if they are equal, include the sub heararchy.
    `XObject` | `execute(XPathContext xctxt)` Execute a binary operation by calling execute on each of the operands, and then calling the operate method on the derived class.
    `void` | `fixupVariables(java.util.Vector vars, int globalsSize)` This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
    `Expression` | `getExpression()` Get the raw Expression object that this class wraps.
    `Expression` | `getLeftOperand()`
    `Expression` | `getRightOperand()`
    `XObject` | `operate(XObject left, XObject right)` Apply the operation to two operands, and return the result.
    `void` | `setExpression(Expression exp)` Set the raw expression object for this object.
    `void` | `setLeftRight(Expression l, Expression r)` Set the left and right operand expressions for this operation.

    - ### Methods inherited from class org.apache.xpath.Expression

      `asIterator, asIteratorRaw, asNode, assertion, bool, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Operation

          public Operation()

  - ### Method Detail

    - #### fixupVariables

          public void fixupVariables(java.util.Vector vars,
                            int globalsSize)

      This function is used to fixup variables from QNames to stack frame indexes at stylesheet build time.
      Specified by:
        `fixupVariables` in class `Expression`
      Parameters:
        `vars` - List of QNames that correspond to variables. This list should be searched backwards for the first qualified name that corresponds to the variable reference qname. The position of the QName in the vector from the start of the vector will be its position in the stack frame (but variables above the globalsTop value will need to be offset to the current stack frame).

    - #### canTraverseOutsideSubtree

          public boolean canTraverseOutsideSubtree()

      Tell if this expression or it's subexpressions can traverse outside the current subtree.
      Overrides:
        `canTraverseOutsideSubtree` in class `Expression`
      Returns:
        true if traversal outside the context node's subtree can occur.

    - #### setLeftRight

          public void setLeftRight(Expression l,
                          Expression r)

      Set the left and right operand expressions for this operation.
      Parameters:
        `l` - The left expression operand.
        `r` - The right expression operand.

    - #### execute

          public XObject execute(XPathContext xctxt)
                          throws TransformerException

      Execute a binary operation by calling execute on each of the operands, and then calling the operate method on the derived class.
      Specified by:
        `execute` in class `Expression`
      Parameters:
        `xctxt` - The runtime execution context.
      Returns:
        The XObject result of the operation.
      Throws:
        `TransformerException`

    - #### operate

          public XObject operate(XObject left,
                        XObject right)
                          throws TransformerException

      Apply the operation to two operands, and return the result.
      Parameters:
        `left` - non-null reference to the evaluated left operand.
        `right` - non-null reference to the evaluated right operand.
      Returns:
        non-null reference to the XObject that represents the result of the operation.
      Throws:
        `TransformerException`

    - #### getLeftOperand

          public Expression getLeftOperand()

      Returns:
        the left operand of binary operation, as an Expression.

    - #### getRightOperand

          public Expression getRightOperand()

      Returns:
        the right operand of binary operation, as an Expression.

    - #### callVisitors

          public void callVisitors(ExpressionOwner owner,
                          XPathVisitor visitor)

      Description copied from interface: `XPathVisitable`
      This will traverse the heararchy, calling the visitor for each member. If the called visitor method returns false, the subtree should not be called.
      Specified by:
        `callVisitors` in interface `XPathVisitable`
      Parameters:
        `owner` - The owner of the visitor, where that path may be rewritten if needed.
        `visitor` - The visitor whose appropriate method will be called.
      See Also:
        `XPathVisitable.callVisitors(ExpressionOwner, XPathVisitor)`

    - #### getExpression

          public Expression getExpression()

      Description copied from interface: `ExpressionOwner`
      Get the raw Expression object that this class wraps.
      Specified by:
        `getExpression` in interface `ExpressionOwner`
      Returns:
        the raw Expression object, which should not normally be null.
      See Also:
        `ExpressionOwner.getExpression()`

    - #### setExpression

          public void setExpression(Expression exp)

      Description copied from interface: `ExpressionOwner`
      Set the raw expression object for this object.
      Specified by:
        `setExpression` in interface `ExpressionOwner`
      Parameters:
        `exp` - the raw Expression object, which should not normally be null.
      See Also:
        `ExpressionOwner.setExpression(Expression)`

    - #### deepEquals

          public boolean deepEquals(Expression expr)

      Description copied from class: `Expression`
      Compare this object with another object and see if they are equal, include the sub heararchy.
      Specified by:
        `deepEquals` in class `Expression`
      Parameters:
        `expr` - Another expression object.
      Returns:
        true if this objects class and the expr object's class are the same, and the data contained within both objects are considered equal.
      See Also:
        `Expression.deepEquals(Expression)`

Copyright © 2014 Apache XML Project. All Rights Reserved.